
EXTERNAL PROCEDURE Unsubscribe
EXTERNAL PROCEDURE Subscribe
EXTERNAL PROCEDURE Fb_connect

DEFINE CLASS FB_Post_Event AS CUSTOM
	HIDDEN oCollection
	cError = ""
	
	PROCEDURE Init
	THIS.oCollection = CREATEOBJECT("MyCollection")
	SET LIBRARY TO LOCFILE("FB_POST_EVENT.FLL") ADDITIVE

	PROCEDURE Connect
	LPARAMETERS tcServer, tcDatabase, tcUser, tcPwd, tnPort
	LOCAL lnParams, lnRet
	lnRet = -1
	lnParams = PCOUNT()
	DO CASE 
		CASE lnParams = 4
			lnRet = FB_CONNECT(tcServer, tcDatabase, tcUser, tcPwd)
		CASE lnParams = 5
			lnRet = FB_CONNECT(tcServer, tcDatabase, tcUser, tcPwd, tnPort)
		OTHERWISE
			THIS.cError = "Wrong count of parameters."
	ENDCASE
	RETURN lnRet

	PROCEDURE Disconnect
	LPARAMETERS lnConn
	LOCAL lnParams, lnRet
	lnRet = -1
	IF FB_DISCONNECT(lnConn)
		lnRet = 1
	ENDIF
	RETURN lnRet

	PROCEDURE Error
	LPARAMETERS nError, cMethod, nLine
	THIS.cError = MESSAGE()
	

	PROCEDURE Sub_As_Method
	LPARAMETERS tnConn, toObject, tcEvent, tcName
	LOCAL cRet, lnRet
	
	lnRet = -1
	cRet = THIS.oCollection.AddElement(tnConn, toObject, tcEvent, tcName,1)
	IF !EMPTY(cRet)
		FB_Subscribe(tnConn, tcEvent,"_screen."+this.Name+".OnFbPostEvent('"+cRet+"',<Msg>, 1)")
		lnRet = 1
	ENDIF
	RETURN lnRet

	PROCEDURE Sub_As_Property
	LPARAMETERS tnConn, toObject, tcEvent, tcName
	LOCAL cRet, lnRet
	
	lnRet = -1
	cRet = 	THIS.oCollection.AddElement(tnConn, toObject, tcEvent, tcName,0)
	IF !EMPTY(cRet)
		FB_Subscribe(tnConn, tcEvent,"_screen."+this.Name+".OnFbPostEvent('"+cRet+"',<Msg>,0)")
		lnRet = 1
	ENDIF
	RETURN lnRet
	
	PROCEDURE Unsubscribe
	LPARAMETERS tnConn, toObject, tcEvent, tcName
	LOCAL lnRet
	lnRet = -1
	THIS.oCollection.RemoveElement(tnConn, toObject, tcEvent, tcName)
	IF FB_Unsubscribe(tnConn, tcEvent)
		lnRet = 1
	ENDIF
	RETURN lnRet
	
	PROCEDURE OnFbPostEvent
	LPARAMETERS tcName, tcMes, tnType
	LOCAL loObject, lcTarget
	IF tnType = 0
		loObject = THIS.oCollection.&tcName..oParent
		lcTarget = THIS.oCollection.&tcName..cName
		loObject.&lcTarget = tcMes
	ELSE
		loObject = THIS.oCollection.&tcName..oParent
		lcTarget = THIS.oCollection.&tcName..cName
		IF ISNULL(loObject)
			&lcTarget(tcMes)
		ELSE
			loObject.&lcTarget(tcMes)
		ENDIF
	ENDIF
	
	PROCEDURE Destroy
	THIS.oCollection = NULL
	RELEASE LIBRARY FB_POST_EVENT.FLL
	
ENDDEFINE

DEFINE CLASS MyElement AS Custom
	oParent = NULL
	nConn = 0
	cName = ""
	cEvent = ""
	nType = 0
	
	PROCEDURE Init
	LPARAMETERS tnConn, toParent, tcEvent, tcName, tnType
	THIS.nConn = tnConn
	THIS.oParent = toParent
	THIS.cName = tcName
	THIS.cEvent = tcEvent
	THIS.nType = tnType
	
	PROCEDURE Destroy
	THIS.oParent = NULL
*	? 'Destroy: '+this.name
	
ENDDEFINE

DEFINE CLASS MyCollection AS Custom

	PROCEDURE AddElement
	LPARAMETERS tnConn, toParent, tcEvent, tcName, tnType
	LOCAL cRet
	
	cRet = ""
	IF EMPTY(THIS.FindElement(tnConn, toParent, tcEvent, tcName))
		cRet = SYS(2015)
		THIS.AddObject( cRet, "MyElement", tnConn, toParent, tcEvent, tcName, tnType)
	ENDIF
	RETURN cRet
	

	PROCEDURE RemoveElement
	LPARAMETERS tnConn, toParent, tcEvent, tcName
	LOCAL oName
	oName = THIS.FindElement(tnConn, toParent, tcEvent, tcName)
	IF !EMPTY( oName )
		THIS.RemoveObject(oName)
	ENDIF

	HIDDEN PROCEDURE FindElement
	LPARAMETERS tnConn, toParent, tcEvent, tcName
	LOCAL i, ret
	ret = ""
	
	FOR i = 1 TO THIS.ControlCount
		IF tnConn # THIS.Controls(i).nConn
			LOOP
		ENDIF
		
		IF ISNULL(toParent) AND !ISNULL(THIS.Controls(i).oParent)
			LOOP
		ENDIF
		IF !ISNULL(toParent) AND ISNULL(THIS.Controls(i).oParent)
			LOOP
		ENDIF
			
		IF !ISNULL(toParent) 
			IF THIS.Controls(i).oParent # toParent
				LOOP
			ENDIF
		ENDIF
			
		IF THIS.Controls(i).cName = tcName ;
			AND THIS.Controls(i).cEvent = tcEvent
				
			ret = THIS.Controls(i).Name
			EXIT
		ENDIF
	ENDFOR
	RETURN ret

	PROCEDURE Destroy
	LOCAL i, obj_cnt
	obj_cnt = THIS.ControlCount
	IF obj_cnt > 0
		LOCAL ARRAY arObjects(obj_cnt)
		FOR i = 1 TO obj_cnt
			arObjects(i) = THIS.Controls(i).Name
		ENDFOR
	
		FOR i = 1 TO obj_cnt
			THIS.RemoveObject(arObjects(i))
		ENDFOR
	ENDIF
ENDDEFINE

